SystemOrganization addCategory: #'Sitemap-Model'!
SystemOrganization addCategory: #'Sitemap-View'!
SystemOrganization addCategory: #'Sitemap-Command'!

PREditCommand subclass: #EditSitemapCommand
	instanceVariableNames: 'serverUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Command'!

EditSitemapCommand subclass: #EditGoogleSitemapCommand
	instanceVariableNames: 'logoColor logoSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Command'!

!EditGoogleSitemapCommand class methodsFor: 'accessing-description' stamp: 'pmm 2/11/2006 08:53'!
descriptionLogoColor
	^GoogleSitemap descriptionLogoColor! !

!EditGoogleSitemapCommand class methodsFor: 'accessing-description' stamp: 'pmm 2/11/2006 08:53'!
descriptionLogoSize
	^GoogleSitemap descriptionLogoSize! !

!EditGoogleSitemapCommand class methodsFor: 'testing' stamp: 'pmm 2/3/2006 18:50'!
isAbstract
	^false! !

!EditGoogleSitemapCommand class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 08:53'!
structureClass
	^GoogleSitemap! !

!EditGoogleSitemapCommand methodsFor: 'events' stamp: 'pmm 2/11/2006 11:01'!
doExecute
	super doExecute.
	self structure logoColor: self logoColor.
	self structure logoSize: self logoSize.! !

!EditGoogleSitemapCommand methodsFor: 'events' stamp: 'pmm 2/11/2006 11:02'!
doInitialize
	super doInitialize.
	self logoColor: self structure logoColor.
	self logoSize: self structure logoSize.! !

!EditGoogleSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/3/2006 19:06'!
logoColor
	^ logoColor! !

!EditGoogleSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/3/2006 19:07'!
logoColor: anObject
	logoColor := anObject! !

!EditGoogleSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/3/2006 19:07'!
logoSize
	^ logoSize! !

!EditGoogleSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/3/2006 19:07'!
logoSize: anObject
	logoSize := anObject! !

!EditSitemapCommand class methodsFor: 'accessing-description' stamp: 'pmm 2/11/2006 11:00'!
descriptionServerUrl
	^GoogleSitemap descriptionServerUrl! !

!EditSitemapCommand class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 11:00'!
label
	^'Edit Sitemap'! !

!EditSitemapCommand methodsFor: 'events' stamp: 'pmm 2/11/2006 11:01'!
doExecute
	super doExecute.
	self structure serverUrl: self serverUrl.! !

!EditSitemapCommand methodsFor: 'events' stamp: 'pmm 2/11/2006 11:02'!
doInitialize
	super doInitialize.
	self serverUrl: self structure serverUrl.! !

!EditSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/11/2006 11:02'!
serverUrl
	^ serverUrl! !

!EditSitemapCommand methodsFor: 'accessing-generated' stamp: 'pmm 2/11/2006 11:02'!
serverUrl: anObject
	serverUrl := anObject! !

EditSitemapCommand subclass: #EditYahooSitemapCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Command'!

!EditYahooSitemapCommand class methodsFor: 'testing' stamp: 'pmm 2/11/2006 11:03'!
isAbstract
	^false! !

!EditYahooSitemapCommand class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 11:03'!
structureClass
	^YahooSitemap! !

PRRawView subclass: #SitemapDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

SitemapDownloadView subclass: #GoogleSitemapDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

GoogleSitemapDownloadView subclass: #GoogleSitemapDownloadGzipView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!GoogleSitemapDownloadGzipView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 12:16'!
isAbstract
	^false! !

!GoogleSitemapDownloadGzipView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 12:16'!
label
	^'Download Gzip'! !

!GoogleSitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
content
	^self generator xmlStringGZipCompressed! !

!GoogleSitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
fileName
	^'sitemap.gz'! !

!GoogleSitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:18'!
mimeType
	^'application/gzip'! !

GoogleSitemapDownloadView subclass: #GoogleSitemapDownloadPlainView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!GoogleSitemapDownloadPlainView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 11:21'!
isAbstract
	^false! !

!GoogleSitemapDownloadPlainView class methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:22'!
label
	^'Download'! !

!GoogleSitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:10'!
content
	^self generator xmlString! !

!GoogleSitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
fileName
	^'sitemap.xml'! !

!GoogleSitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
mimeType
	^'text/xml'! !

!GoogleSitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:52'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: GoogleSitemap ]! !

!GoogleSitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:52'!
generatorClass
	^GoogleSitemapGenerator! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:48'!
content
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:48'!
fileName
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:52'!
generator
	^self generatorClass forServerUrl: self sitemap serverUrl.! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:48'!
mimeType
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'rendering' stamp: 'pmm 2/11/2006 10:48'!
renderContentOn: aRequest
	aRequest 
		contentType: self mimeType;
		attachmentWithFileName: self fileName;
		nextPutAll: self content! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:48'!
sitemap
	^self context structure! !

SitemapDownloadView subclass: #YahooSitemapDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!YahooSitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 10:49'!
isAbstract
	^false! !

!YahooSitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/11/2006 10:49'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: YahooSitemap ]! !

!YahooSitemapDownloadView class methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:49'!
label
	^'Download'! !

!YahooSitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:53'!
content
	^self generator plainString! !

!YahooSitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:53'!
fileName
	^'sitemap.txt'! !

!YahooSitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:52'!
generatorClass
	^YahooSitemapGenerator! !

!YahooSitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/11/2006 10:53'!
mimeType
	^'text/plain'! !

PRStructure subclass: #Sitemap
	instanceVariableNames: 'serverUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

Sitemap subclass: #GoogleSitemap
	instanceVariableNames: 'logoColor logoSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!GoogleSitemap class methodsFor: 'accessing-description' stamp: 'pmm 2/3/2006 18:48'!
descriptionLogoColor
	^(MASingleOptionDescription auto: #logoColor label: 'Logo Color' priority: 600)
		options: self logoColors;
		default: self logoColors first;
		reference: MAStringDescription new;
		beRequired;
		yourself.! !

!GoogleSitemap class methodsFor: 'accessing-description' stamp: 'pmm 2/3/2006 18:48'!
descriptionLogoSize
	^(MASingleOptionDescription auto: #logoSize label: 'Logo Size' priority: 700)
		options: self logoSizes;
		default: self logoSizes last;
		reference: MAStringDescription new;
		beRequired;
		yourself.! !

!GoogleSitemap class methodsFor: 'private' stamp: 'pmm 2/3/2006 19:16'!
dimensionDictionary
	^Dictionary new
		at: '30' put: 110@48;
		at: '40' put: 128@56;
		at: '50' put: 163@71;
		at: '60' put: 176@77;
		yourself! !

!GoogleSitemap class methodsFor: 'accessing-resources' stamp: 'pmm 2/11/2006 10:57'!
icon
	"PRCompatibility compileFileNamed: 'google.png' into: GoogleSitemap class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 0 72 0 0 0 72 0 70 201 107 62 0 0 2 230 73 68 65 84 56 203 157 147 75 139 91 117 0 71 207 125 36 55 153 56 201 60 209 209 116 58 142 20 181 216 42 74 157 130 248 64 208 141 149 10 5 23 182 43 139 32 136 46 74 183 130 138 238 92 136 118 211 149 130 136 8 110 212 133 34 3 42 165 130 193 233 180 153 161 47 107 134 97 198 105 147 76 38 207 155 123 111 110 238 255 231 34 31 64 240 124 128 179 58 199 242 78 223 209 241 19 175 211 161 137 23 20 49 233 22 253 84 142 169 184 74 104 50 224 78 210 164 195 140 19 17 88 227 164 226 54 155 78 138 130 113 1 224 209 147 215 213 31 212 37 73 177 31 200 104 75 117 25 197 146 182 251 210 230 198 174 58 146 90 173 80 81 34 169 47 105 16 74 237 72 127 30 94 148 187 99 205 99 167 178 68 64 127 44 67 181 91 228 235 111 107 220 42 253 78 169 108 211 15 103 169 185 117 14 29 244 120 230 216 18 175 60 110 113 228 126 135 156 233 98 135 21 152 61 189 42 163 80 13 245 245 155 47 189 120 182 164 233 39 126 214 223 117 169 42 105 40 233 142 164 63 174 73 197 163 31 235 225 199 206 106 111 79 82 87 186 50 225 137 133 83 37 25 109 41 148 244 198 71 215 245 192 145 243 170 69 146 209 150 6 166 41 13 19 133 201 200 180 114 171 171 82 121 93 129 186 82 212 85 249 161 130 216 247 230 109 249 177 244 254 249 13 221 253 212 103 90 187 17 41 144 20 106 71 45 5 10 181 169 64 109 41 144 226 193 72 228 171 173 68 85 173 28 68 174 219 178 176 93 216 179 198 72 37 139 60 82 76 67 18 35 39 143 23 123 180 83 243 88 64 38 241 33 147 67 248 216 12 177 227 105 76 45 143 157 142 247 8 48 252 176 126 25 22 135 152 177 26 88 6 43 206 65 98 81 72 32 159 0 86 26 199 128 193 38 33 1 137 41 215 197 110 228 115 8 27 183 49 5 77 97 71 147 208 53 40 229 211 77 25 136 65 78 4 25 72 108 225 152 44 89 4 170 16 101 246 97 123 73 139 52 80 156 158 96 251 198 14 145 51 128 113 143 168 147 99 220 177 241 51 80 195 112 177 82 101 181 30 179 86 131 149 245 44 198 155 160 237 92 193 246 236 12 54 187 28 125 50 6 231 65 62 60 183 70 211 142 176 243 192 16 198 8 184 185 154 225 237 83 151 120 233 185 239 56 113 236 71 150 151 43 200 228 201 89 115 176 255 213 64 146 116 59 148 22 14 95 84 97 234 115 45 95 147 2 197 50 146 212 107 72 67 41 138 165 203 255 72 179 251 223 211 151 223 172 200 104 75 151 102 230 100 15 178 219 8 159 25 111 147 95 127 90 98 110 102 151 227 207 126 197 167 159 84 168 14 32 201 165 105 57 61 122 46 108 52 98 234 189 171 120 227 62 0 153 92 15 107 246 173 178 110 158 59 132 103 70 111 52 35 195 153 119 127 225 194 247 107 68 222 36 164 14 224 228 7 132 245 187 40 220 83 229 133 231 125 62 56 243 50 247 101 179 148 23 230 97 233 228 85 169 51 42 239 191 232 15 146 81 219 161 164 126 95 127 29 184 87 110 234 181 119 120 250 2 255 139 47 252 29 254 5 25 110 13 171 255 102 75 149 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!GoogleSitemap class methodsFor: 'testing' stamp: 'pmm 2/2/2006 10:40'!
isAbstract
	^false! !

!GoogleSitemap class methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:41'!
label
	^'Google Sitemap'! !

!GoogleSitemap class methodsFor: 'private' stamp: 'pmm 2/2/2006 10:46'!
logoColors
	^#('wht' 'gry' 'blk')! !

!GoogleSitemap class methodsFor: 'private' stamp: 'pmm 2/2/2006 10:46'!
logoSizes
	^#('30' '40' '50' '60')! !

!GoogleSitemap methodsFor: 'visiting' stamp: 'pmm 2/11/2006 09:35'!
accept: aVisitor
	aVisitor visitGoogleSitemap: self! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 08:54'!
editCommandClass
	^EditGoogleSitemapCommand! !

!GoogleSitemap methodsFor: 'initialize-release' stamp: 'pmm 2/2/2006 10:56'!
initialize
	super initialize.
	self logoColor: self class logoColors first.
	self logoSize: self class logoSizes last! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:53'!
loginText
	^'Login at Google Sitemaps'! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:39'!
loginUrl
	^'https://www.google.com/webmasters/sitemaps/login'! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoColor
	^logoColor! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoColor: aString 
	logoColor := aString! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/3/2006 19:17'!
logoHeight
	^(self class dimensionDictionary at: self logoSize) y! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoSize
	^logoSize! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoSize: aString 
	logoSize := aString! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:50'!
logoText
	^'Google Sitemaps'! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:48'!
logoUrl
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'https://www.google.com/webmasters/sitemaps/images/logo_';
			nextPutAll: self logoColor;
			nextPut: $_;
			nextPutAll: self logoSize;
			nextPutAll: '.gif' ]! !

!GoogleSitemap methodsFor: 'accessing' stamp: 'pmm 2/3/2006 19:16'!
logoWidth
	^(self class dimensionDictionary at: self logoSize) x! !

!Sitemap class methodsFor: 'accessing-description' stamp: 'pmm 2/11/2006 10:42'!
descriptionServerUrl
	^(MAStringDescription auto: #serverUrl label: 'Server URL' priority: 500)
		comment: 'The full server url including the protocol, optional port, optional path and ending with a /.';
		beRequired;
		yourself.! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:48'!
loginText
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:47'!
loginUrl
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:48'!
logoHeight
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:49'!
logoText
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:48'!
logoUrl
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:48'!
logoWidth
	self subclassResponsability! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:44'!
serverUrl
	^serverUrl! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:44'!
serverUrl: aString 
	serverUrl := aString! !

Sitemap subclass: #YahooSitemap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!YahooSitemap class methodsFor: 'accessing-resources' stamp: 'pmm 2/11/2006 10:58'!
icon
	"PRCompatibility compileFileNamed: 'yahoo-1.png' into: YahooSitemap class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 0 72 0 0 0 72 0 70 201 107 62 0 0 0 97 73 68 65 84 56 203 237 82 65 14 192 48 8 130 253 255 207 246 178 46 148 97 60 47 153 151 38 136 128 166 192 95 44 160 218 38 192 81 224 126 171 2 56 25 24 23 80 178 186 111 156 65 244 234 34 111 146 15 187 123 220 209 99 235 176 165 60 19 164 36 201 89 241 40 48 28 141 42 250 82 238 174 78 57 94 72 232 26 157 249 211 31 255 199 135 106 1 251 54 26 19 91 24 94 77 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!YahooSitemap class methodsFor: 'testing' stamp: 'pmm 2/11/2006 09:52'!
isAbstract
	^false! !

!YahooSitemap class methodsFor: 'accesing' stamp: 'pmm 2/11/2006 09:52'!
label
	^'Yahoo!! Sitemap'! !

!YahooSitemap methodsFor: 'visiting' stamp: 'pmm 2/11/2006 09:55'!
accept: aVisitor
	aVisitor visitYahooSitemap: self! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 11:04'!
editCommandClass
	^EditYahooSitemapCommand! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:54'!
loginText
	^'Login at Yahoo!! Sitemaps'! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:54'!
loginUrl
	^'http://submit.search.yahoo.com/free/request'! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:56'!
logoHeight
	^33! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:57'!
logoText
	^'Yahoo!! Sitemaps'! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:56'!
logoUrl
	^'http://sec.yimg.com/i/us/nt/ma/ma_search_1.gif'! !

!YahooSitemap methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:56'!
logoWidth
	^230! !

!PRViewRenderer methodsFor: '*Sitemap' stamp: 'pmm 2/11/2006 11:14'!
visitSitemap: aSitemap
	html image
		width: aSitemap logoWidth;
		height: aSitemap logoHeight;
		altText: aSitemap logoText;
		url: aSitemap logoUrl.
	html break.
	html anchor
		url: aSitemap loginUrl;
		text: aSitemap loginText! !

!PRVisitor methodsFor: '*Sitemap' stamp: 'pmm 2/11/2006 09:34'!
visitGoogleSitemap: aGoogleSitemap
	self visitSitemap: aGoogleSitemap! !

!PRVisitor methodsFor: '*Sitemap' stamp: 'pmm 2/2/2006 12:21'!
visitSitemap: aSitemap
	self visitStructure: aSitemap! !

!PRVisitor methodsFor: '*Sitemap' stamp: 'pmm 2/11/2006 09:39'!
visitYahooSitemap: aYahooSitemap
	self visitSitemap: aYahooSitemap! !

PRVisitor subclass: #SitemapGenerator
	instanceVariableNames: 'serverUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

SitemapGenerator subclass: #GoogleSitemapGenerator
	instanceVariableNames: 'document root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!GoogleSitemapGenerator commentStamp: '<historical>' prior: 0!
http://www.google.com/schemas/sitemap/0.84/
https://www.google.com/webmasters/sitemaps/docs/en/protocol.html
http://www.xml.com/pub/a/2005/10/26/google-site-maps.html
http://sitemaps.blogspot.com/2005/09/using-oai-pmh-with-google-sitemaps.html!

!GoogleSitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 12/9/2005 00:14'!
exmaple1
	| sitemap |
	sitemap := self forKernel: 'default' server: 'http://www.pier.com/'.
	! !

!GoogleSitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 2/2/2006 12:08'!
forKernel: aKernelString server: aServerString
	| kernel root context sitemap |
	kernel := PRKernel instances detect: [ :each | each name = aKernelString ].
	root := kernel root.
	context := PRContext kernel: kernel structure: root.
	PRCurrentContext
		use: context
		during: [ sitemap := self forServerUrl: aServerString ].
	^sitemap
	! !

!GoogleSitemapGenerator methodsFor: 'private' stamp: 'pmm 2/11/2006 09:04'!
add: aPage
	| url location timestamp lastModification isoString |
	url := XMLElement named: 'url'.
	location := XMLElement named: 'location'.
	location addContent: (XMLStringNode string: (self urlOf: aPage)).
	url addElement: location.
	timestamp := aPage modificationTimestamp.
	timestamp isNil ifFalse: [
		lastModification := XMLElement named: 'lastmod'.
		isoString := String streamContents: [ :stream | 
			timestamp printOn: stream withLeadingSpace: false ].
		lastModification addContent: (XMLStringNode string: isoString).
		url addElement: lastModification ].
	self root addElement: url! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document
	^document! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document: anXmlDocument 
	document := anXmlDocument! !

!GoogleSitemapGenerator methodsFor: 'initialize-release' stamp: 'pmm 2/3/2006 19:36'!
initialize
	super initialize.
	self document: (XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself).
	self root: (XMLElement named: 'urlset').
	self root attributeAt: 'xmlns' put: 'http://www.google.com/schemas/sitemap/0.84'.
	self root attributeAt: 'xmlns:xsi' put: 'http://www.w3.org/2001/XMLSchema-instance'.
	self root attributeAt: 'xsi:schemaLocation' put: 'http://www.google.com/schemas/sitemap/0.84
	http://www.google.com/schemas/sitemap/0.84/sitemap.xsd'.
	document addElement: root
	! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
root
	^root! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:56'!
root: anXmlElement 
	root := anXmlElement! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/9/2005 00:22'!
xmlString
	^String streamContents: [ :stream |
		self document printCanonicalOn: stream ].! !

!GoogleSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/3/2006 22:42'!
xmlStringGZipCompressed
	^String streamContents: [ :stream |
		| gzipStream |
		gzipStream := GZipWriteStream on: stream.
		self document printCanonicalOn: gzipStream.
		gzipStream close ].! !

!SitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 2/11/2006 11:18'!
forServerUrl: aServerString
	| generator |
	generator := self new serverUrl: aServerString; yourself.
	generator generate.
	^generator
	! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 2/11/2006 08:58'!
add: aPage
	self subclassResponsability! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 08:57'!
context
	^PRCurrentContext value! !

!SitemapGenerator methodsFor: 'public' stamp: 'pmm 2/11/2006 08:57'!
generate
	^self visit: PRCurrentContext value root! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 2/11/2006 08:58'!
ignoreChildrenOf: aPage
	^self ignore: aPage! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 2/11/2006 09:00'!
ignore: aPage
	^aPage title = 'Environment'
		or: [ aPage title = 'Management' ]! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 08:57'!
serverUrl
	^serverUrl! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 08:57'!
serverUrl: aString 
	serverUrl := aString! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 2/11/2006 09:03'!
urlOf: aStructure
	^String streamContents: [ :stream |
		stream nextPutAll: self serverUrl.
		aStructure parents
			do: [ :each | stream nextPutAll: each title ]
			separatedBy: [ stream nextPut: $/ ] ]! !

!SitemapGenerator methodsFor: 'visiting-decoration' stamp: 'pmm 2/11/2006 08:57'!
visitChildren: anObject
	| decorated |
	decorated := anObject decorated.
	(self ignoreChildrenOf: decorated) ifFalse: [
		decorated enumerator do: [ :each |
			self visit: each ] ]! !

!SitemapGenerator methodsFor: 'visiting-structure' stamp: 'pmm 2/11/2006 08:57'!
visitPage: aPage
	(self ignore: aPage) ifFalse: [
		self add: aPage ].! !

SitemapGenerator subclass: #YahooSitemapGenerator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!YahooSitemapGenerator methodsFor: 'private' stamp: 'pmm 2/11/2006 09:05'!
add: aStructure
	self stream
		nextPutAll: (self urlOf: aStructure);
		cr! !

!YahooSitemapGenerator methodsFor: 'initialize-release' stamp: 'pmm 2/11/2006 09:02'!
initialize
	super initialize.
	self stream: (WriteStream on: (String new: 100)).! !

!YahooSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:05'!
plainString
	^self stream contents! !

!YahooSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:02'!
stream
	^stream! !

!YahooSitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/11/2006 09:02'!
stream: aStream 
	stream := aStream! !
